		**********************
		*  StarsBlanker.asm  *
		**********************

		COMMENT	/
StarsBlanker a t assembl avec le Macro68  DigiSoft. 
Pour assembler avec un autre assembleur, il suffit de changer les directives 
propres au Macro68 (voir la fin du source pour de plus amples informations).
			/

;-------------- Perte de 72 octets  chaque excution avec SUBTASK ???
;-------------- Et plante de temps en temps.
;-------------- Pour l'instant, il ne faut pas l'utiliser (dsol !!!).
;SUBTASK		SET	1
;CPR		SET	1
_M68020		SET	1

		IFD	_M68020
		MC68020
		ELSE
		MC68000
		ENDC
		IFND	CPR
		EXEOBJ
		IFD	SUBTASK
		IFD	_M68020
		OBJFILE	TaskStarsBlanker020
		ELSE
		OBJFILE	TaskStarsBlanker
		ENDC
		ELSE
		IFD	_M68020
		OBJFILE	StarsBlanker020
		ELSE
		OBJFILE	StarsBlanker
		ENDC
		ENDC
		ELSE
		IFND	SUBTASK
		IFD	_M68020
		OBJFILE	StarsBlanker020.o
		ELSE
		OBJFILE	StarsBlanker.o
		ENDC
		ELSE
		IFD	_M68020
		OBJFILE	TaskStarsBlanker020.o
		ELSE
		OBJFILE TaskStarsBlanker.o
		ENDC
		ENDC
		ADDSYM
;-------------- CPR V6.50 est un peu perdu avec le format LATTICE4
		DEBUG	ON,LATTICE4,CODE,DATA
		ENDC
		STRICT
		NEWSYNTAX
		MULTIPASS
		ESCAPESTR

MENU_LABEL1 	EQU 	0
MENU_LABEL2 	EQU 	1
GAG_LABEL1 	EQU 	2
TEXT_NOTE 	EQU 	3
MSG_NOINPUT 	EQU 	4
MSG_NOTIMER 	EQU 	5
MSG_NOCOM 	EQU 	6
MSG_PORTFOUND 	EQU 	7
ICON_ERROR 	EQU 	8
GFX_ERROR 	EQU 	9
CX_ERROR 	EQU 	10
GAD_ERROR 	EQU 	11

	STRUCTURE LocaleInfo,0
		APTR li_LocaleBase
		APTR li_Catalog
	LABEL LocaleInfo_SIZEOF

_LVOOpenCatalogA	EQU	-150 
_LVOCloseCatalog	EQU	-36 
_LVOGetCatalogStr	EQU	-72 

MAXTIME		EQU	9999
MINTIME		EQU	1
ZMAX		EQU	600
DEPTH		EQU	2
WIDTH		EQU	320
HEIGHT		EQU	256

		IFD	SUBTASK
NBSTARS		EQU	210*2
STACKSIZE	EQU	100
		ELSE
NBSTARS		EQU	210
		ENDC
SIZETABLE	EQU	NBSTARS*6
	
pushm		MACRO
reglist		setrl \1
		movem.l reglist,-(SP)
		ENDM

popm		MACRO
		movem.l (SP)+,reglist
		ENDM		

DETACHSTARTUP	MACRO	; codestart, stack, pri
			;   1		2   3   
SEGNAME		EQUSTR	"\1",".name"
PRI		EQU	\3
DETACHED	EQU	1
HELP		EQU	3*4
KEY		EQU	2*4

		SECTION	DetachCLI,CODE

DetachCLI
		move.l	($4).W,(_SysBase)
		suba.l	a1,a1
		CALL	_SysBase,FindTask
		movea.l	d0,a5
		tst.l	(pr_CLI,a5)
		seq	(fromWB)
		beq.w	FromWorkbench

		bsr.w	OpenDos
		move.l	d0,(_DOSBase)
		beq.w	NoDos

		movea.l	d0,a6
		move.l	#hello.msg,d1
		CALL	PutStr
		move.l	#template,d1
		move.l	#Args.first,d2
		moveq	#0,d3
		CALL	ReadArgs
		move.l	d0,(rdargs)
		beq.w	freeArgs

		tst.l	(Args.first+HELP)
		beq.b	.NoHelp
		move.l	(rdargs),d1
		CALL	_DOSBase,FreeArgs
		clr.l	(rdargs)
		moveq	#DOS_RDARGS,d1
		moveq	#0,d2
		CALL	AllocDosObject
		move.l	d0,(rda)
		beq.w	freeArgs

		movea.l	d0,a2
		move.l	#usage.msg,d1
		CALL	PutStr
		CALL	Input
		move.l	d0,d1
		lea	(buffer),a3
		move.l	a3,d2
		move.l	#512-1,d3
		CALL	FGets
		lea	(RDA_Source,a2),a0
		move.l	a3,(CS_Buffer,a0)
		move.l	#512,(CS_Length,a0)

		move.l	#template.Help,d1
		move.l	#Args.first,d2
		move.l	a2,d3
		CALL	_DOSBase,ReadArgs
		move.l	d0,(rdargs)
		beq.w	freeArgs

.NoHelp		lea	(Args.first),a0
		lea	(rdargs.show),a1
		move.l	(a0)+,(a1)+
		tst.l	(a0)
		beq.b	.defaultTime
		movea.l	(a0),a0
		move.l	(a0),d0
		move.l	d0,(DecBuffer)
		move.l	#DecBuffer,(a1)
.defaultTime	move.l	(Args.first+KEY),d0
		beq.b	.NoKey
		movea.l	d0,a0
		lea	(HotBuffer),a1
		STRCPY	a0,a1
		move.l	#HotBuffer,(rdargs.hotkey)

.NoKey		IFNE	DETACHED
		move.l	(DetachCLI-4,PC),(ProcessTags+4)
		movea.l	(pr_CLI,a5),a1
		adda.l	a1,a1
		adda.l	a1,a1
		movea.l	(cli_Module,a1),a0
		adda.l	a0,a0
		adda.l	a0,a0
		clr.l	(a0)	
		move.l	#ProcessTags,d1
		CALL	_DOSBase,CreateNewProc
		ELSE
		jsr	(\1).L
		ENDC

		bsr.b	freeArgs
		moveq	#RETURN_OK,d0
		rts
			
NoDos		
		moveq	#RETURN_FAIL,d0
		rts

FromWorkbench
		lea	(pr_MsgPort,a5),a2
		movea.l	a2,a0
		CALL	WaitPort
		movea.l	a2,a0
		CALL	GetMsg
		move.l	d0,(_WBMsg)

		bsr.b	OpenDos
		move.l	d0,(_DOSBase)
		beq.b	NoDos

		jsr	(\1).L
		push	d0
		bsr.b CloseDos

		CALL	Forbid
		movea.l	(_WBMsg),a1
		CALL	ReplyMsg
		pop	d0
		rts

OpenDos		
		lea	(DOSName),a1
		moveq	#37,d0
		JUMP	OpenLibrary

freeArgs	
		move.l	(rdargs),d1
		beq.b	.noRdargs
		CALL	_DOSBase,FreeArgs

.noRdargs	
		move.l	(rda),d2
		beq.b	CloseDos
		moveq	#DOS_RDARGS,d1
		CALL	_DOSBase,FreeDosObject

CloseDos	
		movea.l	(_DOSBase),a1
		JUMP	_SysBase,CloseLibrary

		IFNE	DETACHED
		SECTION	StarsBlanker,CODE
		ENDC

		SECTION	__MERGED,DATA

		IFNE	DETACHED

SegmentName	dc.b	SEGNAME,0
		CNOP	0,4
ProcessTags	dc.l	NP_Seglist,0
		dc.l	NP_FreeSeglist,TRUE
		dc.l	NP_StackSize,\2
		dc.l	NP_Name,SegmentName
		dc.l	NP_Priority,\3
		dc.l	TAG_DONE
		ENDC

_SysBase	ds.l	1
_DOSBase	ds.l	1
_WBMsg		ds.l	1
Args.first	ds.l	4
rda		ds.l	1
rdargs		ds.l	1
HotBuffer	ds.b	256
DecBuffer	ds.l	8
rdargs.show	ds.l	1
rdargs.time	ds.l	1
rdargs.hotkey	ds.l 	1
		ENDM
	
ID_HOTKEY	equ	1
MYGAD_INT	equ	0
MYGAD_STRING	equ	1
			
		MACFILE	usermacs.i

		DETACHSTARTUP	StarsBlanker,4096,0

		SECTION	StarsBlanker,CODE
	
StarsBlanker	lea	(LocaleName),a1
		moveq	#0,d0
		CALL	_SysBase,OpenLibrary
		move.l	d0,(_LocaleBase)
		beq.w	Quit
		movea.l	d0,a6
		suba.l	a0,a0
		movea.l	a0,a2
		lea	(CatalogName),a1
		CALL	OpenCatalogA
		lea	(localeinfo),a0
		move.l	a6,(a0)+
		move.l	d0,(a0)

		suba.l	a1,a1
		CALL	_SysBase,FindTask
		move.l	d0,(_Task)

		lea	(IntuitionName),a1
		moveq	#37,d0
		CALL	OpenLibrary
		move.l	d0,(_IntuitionBase)
		beq.w	NoInt

		CALL	Forbid
		lea	(NamePort),a1
		CALL	FindPort
		move.l	d0,d2
		CALL	Permit
		tst.l	d2
		beq.b	.NoPort
		MESSAGE <locale>,MSG_PORTFOUND
		bra.w	NoGfx

.NoPort		lea	(GraphicsName),a1
		moveq	#37,d0
		CALL	OpenLibrary
		move.l	d0,(_GfxBase)
		beq.w	NoGfx
		
		lea	(IconName),a1
		moveq	#37,d0
		CALL	OpenLibrary
		move.l	d0,(_IconBase)
		beq.w	NoIcon

		lea	(CommoditiesName),a1
		moveq	#37,d0
		CALL	OpenLibrary
		move.l	d0,(_CXBase)
		beq.w	NoCX

		lea	(GadToolsName),a1
		moveq	#37,d0
		CALL	OpenLibrary
		move.l	d0,(_GadToolsBase)
		beq.w	NoGadTools
	
		bsr.w	InitInputEvents
		tst.l	d0
		bne.b	.InputOK

		MESSAGE	<locale>,MSG_NOINPUT
		bsr.w	CleanInputEvents
		bra.w	FreeLib

.InputOK	movea.l	(InputPort),a0
		move.b	(MP_SIGBIT,a0),d0
		moveq	#0,d1
		bset	d0,d1
		move.l	d1,(inputSig)

		bsr.w	InitTimer
		tst.l	d0
		beq.b	.TimerOK
		MESSAGE	<locale>,MSG_NOTIMER
		bra.w	FreeDev

.TimerOK	movea.l	(TimePort),a0
		move.b	(MP_SIGBIT,a0),d0
		moveq	#0,d1
		bset	d0,d1
		move.l	d1,(timeSig)

		tst.b	(fromWB)
		beq.b	.CLIStart
		bsr.w	ReadWBArgs
		move.l	(rdargs.time),d1
		beq.b	NoTime
		lea	(Time),a0
		move.l	a0,d2
		CALL	_DOSBase,StrToLong
		bra.b	GoodTime

.CLIStart	tst.l	(rdargs.time)
		beq.b	NoTime
		movea.l	(rdargs.time),a0
		move.l	(a0),(Time)

GoodTime	lea	(Time),a0
		move.l	#MAXTIME,d2
		moveq	#MINTIME,d3
		move.l	(a0),d0
		bpl.b	.TestMax
		move.l	d3,(a0)
		bra.b	NoTime
.TestMax	cmp.l	d2,d0
		bcs.b	NoTime
		move.l	d2,(a0)
NoTime		tst.l	(rdargs.hotkey)
		beq.b	.NotHotkey	
		move.l	(rdargs.hotkey),(Key)	

.NotHotkey	bsr.w	InitCom
		tst.l	d0
		bne.b	.ComOk
		MESSAGE	<locale>,MSG_NOCOM
		bra.w	FREE
		
.ComOk		movea.l	(Broker),a0
		moveq	#TRUE,d0
		CALL	_CXBase,ActivateCxObj

		tst.l	(rdargs.show)
		beq.b	.NoWind
		bsr.w	OpenUserWindow
		move.l	(mywindow),d0
		beq.w	FREE

.NoWind		move.l 	#DEPTH*SIZETABLE,d0
		move.l	#MEMF_PUBLIC|MEMF_CLEAR,d1
		CALL	_SysBase,AllocMem
		tst.l	d0
		beq.w	FREEALL
		movea.l	d0,a0
		move.l	a0,(OldCoords)
		lea	(SIZETABLE,a0),a0
		move.l	a0,(NewCoords)

		move.l	#NBSTARS-1,d3
		movea.l (NewCoords),a0
..InitTable	bsr.w CalcCoords
		move.w d0,(a0)+
		bsr.w	CalcCoords
		move.w d0,(a0)+
		bsr.w	CalcCoords
		andi.w #$1ff,d0
		move.w d0,(a0)+
		dbf d3,..InitTable

		IFD	SUBTASK
		movea.l	(_Task),a1
		moveq	#PRI+1,d0
		CALL	_SysBase,SetTaskPri
		moveq	#-1,d0
		CALL	AllocSignal
		move.l	d0,(globalSig)
		bmi.b	.NoSig
		lea	(taskName),a0
		moveq	#0,d0
		moveq	#STACKSIZE,d1
		lea	(Stars,PC),a1
		bsr.w	CreateTask
		move.l	d0,(subTask)
		beq.b	.NoTask
		ENDC

		bsr.w	StartTimer
		bsr.w	ProcessMsg


		IFD	SUBTASK
		movea.l	(subTask),a2
		movea.l	a2,a1
		move.l	#SIGBREAKF_CTRL_C,d0
		CALL	_SysBase,Signal
		move.l	(globalSig),d1
		moveq	#0,d0
		bset	d1,d0
		CALL	Wait
		movea.l	a2,a1
		CALL	RemTask
.NoTask		move.l	(globalSig),d0
		CALL	FreeSignal
.NoSig
		ENDC

		movea.l (OldCoords),a1
		move.l #DEPTH*SIZETABLE,d0
		CALL	_SysBase,FreeMem

FREEALL		bsr.w	CloseUserWindow
FREE		bsr.w	CleanCom
FreeDev		bsr.w	CleanTimer
		bsr.w	CleanInputEvents

FreeLib		move.l	(_GadToolsBase),d0
		bne.b	.GadtoolsOk
		MESSAGE	<locale>,GAD_ERROR
		bra.b	NoGadTools
.GadtoolsOk	movea.l	d0,a1
		CALL	_SysBase,CloseLibrary

NoGadTools	move.l	(_CXBase),d0
		bne.b	.CXOk
		MESSAGE	<locale>,CX_ERROR
		bra.b	NoCX
.CXOk		movea.l	d0,a1
		CALL	_SysBase,CloseLibrary

NoCX		move.l	(_IconBase),d0
		bne.b	.IconOk
		MESSAGE	<locale>,ICON_ERROR
		bra.b	NoIcon
.IconOk		movea.l	d0,a1	
		CALL	_SysBase,CloseLibrary

NoIcon		move.l	(_GfxBase),d0
		bne.b	.GfxOk
		MESSAGE	<locale>,GFX_ERROR
		bra.b	NoGfx
.GfxOk		movea.l	d0,a1
		CALL	_SysBase,CloseLibrary

NoGfx		move.l	(_IntuitionBase),d0
		beq.b	NoInt
		movea.l	d0,a1
		CALL	_SysBase,CloseLibrary

NoInt		lea	(localeinfo),a0
		movea.l	(a0)+,a6
		move.l	a6,d0
		beq.b	Quit
		movea.l	(a0),a0
		CALL	CloseCatalog
		movea.l	a6,a1
		CALL	_SysBase,CloseLibrary

Quit		moveq	#0,d0
		rts
;---------------
		ENTRY	ProcessMsg,d2-d7
		clr.l	(BlankerScreen)
		move.b	#1,(Activate)
		moveq	#0,d3
		moveq	#0,d4	
		moveq	#0,d5
		movea.l	(BrokerPort),a0
		move.b	(MP_SIGBIT,a0),d0
		bset	d0,d3
		bset	d0,d4
		move.l	(timeSig),d7
		or.l	d7,d3
		move.l	(inputSig),d0
		or.l	d0,d3

		moveq	#1,d6

LOOP		tst.l	d6
		beq.w	ProcessMsg_done
		move.l	(mywindow),d0
		beq.b	.NoWindMsg
		movea.l	d0,a0
		movea.l	(wd_UserPort,a0),a0
		move.b	(MP_SIGBIT,a0),d0
		bset	d0,d3
		bset	d0,d5
.NoWindMsg	move.l	d3,d0
		CALL	_SysBase,Wait
		move.l	d0,d2
		and.l	d5,d0
		beq.b	.noEventWindow
		bsr.w	HandleWindowEvents
		move.l	d0,d6
		bra.b	LOOP
.noEventWindow
		move.l	d2,d0
		and.l	d4,d0
		beq.b	BlankerLoop
		bsr.w	HandleCXEvents
		move.l	d0,d6
		bra.b	LOOP
	
BlankerLoop	bsr.w	StartTimer
		move.l	(inputSig),d0
		or.l	d7,d0
		CALL	_SysBase,Wait
		move.l	d0,d2
		and.l	(inputSig),d0
		bne.w	CloseBlanker

		move.l	d2,d0
		and.l	d7,d0
		beq.b	NoTimerEvents
		tst.b	(Activate)
		beq.b	NoTimerEvents
		tst.l	(BlankerScreen)
		IFD	SUBTASK
		bne.b	BlankerLoop
		ELSE
		beq.b	.noScreen
		bsr.w	Stars
		bra.b	BlankerLoop
		ENDC
.noScreen	bsr.b	OpenBlanker
		move.l	d0,d6
		bne.b	BlankerLoop

NoTimerEvents	bsr.w	StartTimer
		bra.w	LOOP
		DONE	ProcessMsg
;--------------
OpenBlanker
		pushm	d2-d3/a2
		moveq	#1,d3
		tst.l	(BlankerScreen)
		bne.w	OpenBlanker_done
		move.l	(TimeRequest),d2
		movea.l	(TimePort),a0
		CALL	_SysBase,GetMsg
		cmp.l	d2,d0
		bne.b	OpenBlanker_done	
		lea	(TCount),a2
		addq.l	#1,(a2)
		move.l	(a2),d2
		move.l	(Time),d1
		IFEQ	_EVAL(mc68020)
		mulu.w	#60,d1
		ELSE
		mulu.l	#60,d1
		ENDC
		cmp.l	d1,d2
		bcs.b	OpenBlanker_done
		lea	(blankscreentags),a1
		CALL	_IntuitionBase,OpenScreenTagList
		move.l	d0,(BlankerScreen)
		bne.b	.screenOpen
		moveq	#0,d3
		bra.b	OpenBlanker_done

.screenOpen	movea.l	d0,a0
		lea	(sc_BitMap,a0),a1
		move.l	(bm_Planes,a1),(Plan1)
		move.l	(bm_Planes+4,a1),(Plan2)
		lea	(sc_ViewPort,a0),a0
		lea	(ColorTable),a1
		moveq	#4,d0
		CALL	_GfxBase,LoadRGB4
		lea	(_custom).L,a2
		move.w	#DMAF_SPRITE,(dmacon,a2)
OpenBlanker_done
		move.l	d3,d0
		popm
		rts
;--------------
CloseBlanker	push	a2
		move.l	(BlankerScreen),d0
		beq.b	CloseBlanker_done
		movea.l	d0,a0
		CALL	_IntuitionBase,CloseScreen
		clr.l	(BlankerScreen)
		lea	(_custom).L,a2
		move.w	#DMAF_SETCLR|DMAF_SPRITE,(dmacon,a2)
CloseBlanker_done
		pop	a2
		bra.w	NoTimerEvents
;--------------
		IFD	SUBTASK
		ENTRY	CreateTask,d2-d3/a2-a5
		move.l	d0,d3
		move.l	d1,d2
		addq.l	#3,d2
		andi.w	#~3,d2
		movea.l	a0,a3
		movea.l	a1,a2
		lea	(memlist),a0
		move.l	d2,(ml_SizeStack,a0)
		CALL	_SysBase,AllocEntry
		bclr.l	#31,d0
		beq.b	.AllocOK
		moveq	#0,d0
		bra.b	 CreateTask_done

.AllocOK	movea.l	d0,a4
		movea.l	(ml_AdrTask,a4),a5
		move.l	(ml_AdrStack,a4),d0
		move.l	d0,(TC_SPLOWER,a5)
		add.l	d2,d0
		move.l	d0,(TC_SPUPPER,a5)
		move.l	d0,(TC_SPREG,a5)
		move.b	#NT_TASK,(LN_TYPE,a5)
		move.b	d3,(LN_PRI,a5)
		move.l	a3,(LN_NAME,a5)
		lea	(TC_MEMENTRY,a5),a3
		movea.l	a3,a0

;-------------- Macro NEWLIST
		move.l	a0,(LH_TAILPRED,a0)	
		addq.l	#LH_TAIL,a0		
		clr.l	(a0)			
		move.l	a0,-(a0)	
	
		movea.l	a3,a0
		movea.l	a4,a1		
		CALL	AddHead
		movea.l	a5,a1
		suba.l	a3,a3
		CALL	AddTask
		cmpi.w	#37,(LIB_VERSION,a6)
		bcs.b	.Ok
		tst.l	d0
		bne.b	.Ok
		movea.l	a4,a0
		CALL	FreeEntry
		moveq	#0,d0
		bra.b	CreateTask_done
.Ok		move.l	a5,d0
		DONE	CreateTask
		ENDC
;--------------
Stars		
		IFND	SUBTASK
		pushm	d2-d7/a2-a5
		ELSE
		moveq	#0,d0
		moveq	#0,d1
		CALL	_SysBase,SetSignal
		tst.l	d0
		bne.w	Stars_done
		ENDC
		tst.l	(BlankerScreen)
		beq.w	StarsAgain
		movea.l (NewCoords),a4
		move.l	#NBSTARS-1,d3
		movea.l	(OldCoords),a5
MoveStars
		move.w	(a4)+,d4
		move.w	(a4)+,d5
		move.w	(a4),d6
		subq.w	#2,(a4)+
		tst.w	d6
		ble.w	ChangeCoords
		ext.l	d4
		divs.w	d6,d4
		addi.w	#WIDTH/2,d4
		ext.l	d5
		divs.w	d6,d5
		addi.w	#HEIGHT/2,d5
		tst.w	d4
		blt.w	ChangeCoords
		tst.w	d5
		blt.w	ChangeCoords
		cmpi.w	#WIDTH-1,d4
		bgt.w	ChangeCoords
		cmpi.w	#HEIGHT-1,d5
		bgt.w	ChangeCoords
		move.w	(a5),d0
		move.w	d4,(a5)+
		move.w	(a5),d1
		move.w	d5,(a5)+
		bsr.w	ClearStars
		move.w	d4,d0
		move.w	d5,d1
		mulu.w	#40,d1
		move.w	d0,d2
		asr.w	#3,d2
		add.w	d2,d1
		asl.w	#3,d2
		sub.w	d0,d2
		subq.b	#1,d2
		cmpi.w	#ZMAX-200,d6
		bgt.b	.FirstPlane
		cmpi.w	#ZMAX-300,d6
		bgt.b	.SecondPlane
		bra.b	.AllPlanes
.FirstPlane
		movea.l	(Plan1),a1
		adda.l	d1,a1
		bset	d2,(a1)
		bra.b	StarsLoop
.SecondPlane
		movea.l	(Plan2),a1
		adda.l	d1,a1
		bset	d2,(a1)
		bra.b	StarsLoop
.AllPlanes
		movea.l	(Plan1),a1
		adda.l	d1,a1
		bset	d2,(a1)
		movea.l	(Plan2),a1
		adda.l	d1,a1
		bset	d2,(a1)
StarsLoop	dbf	d3,MoveStars
StarsAgain	IFD	SUBTASK
		bra.w	Stars
Stars_done	movea.l	(_Task),a1
		move.l	(globalSig),d1
		moveq	#0,d0
		bset	d1,d0
		CALL	_SysBase,Signal
		moveq	#0,d0
		JUMP	Wait
		ELSE
		popm
		rts
		ENDC
;--------------
CalcCoords
		move.w	(_custom+vhposr),d0
		lea	(Rnd),a3
		muls.w	(a3),d0
		addi.w	#4683,d0
		move.w	d0,(a3)
		rts
;--------------
ChangeCoords
		subq.l	#6,a4
		bsr.b	CalcCoords
		move.w	d0,(a4)+
		bsr.b	CalcCoords
		move.w	d0,(a4)+
		move.w	#ZMAX,(a4)+
		bra.b	StarsLoop
;--------------
ClearStars
		mulu.w	#40,d1		
		move.w	d0,d2
		asr.w	#3,d2
		add.w	d2,d1
		asl.w	#3,d2
		sub.w	d0,d2
		subq.b	#1,d2
		movea.l	(Plan1),a1
		adda.l	d1,a1
		bclr	d2,(a1)
		movea.l	(Plan2),a1
		adda.l	d1,a1
		bclr	d2,(a1)
		rts			
;--------------
		ENTRY	StartTimer
		movea.l	(TimeRequest),a1
		CALL	_SysBase,CheckIO
		beq.b	StartTimer_done
		move.w	#TR_ADDREQUEST,(IO_COMMAND,a1)
		move.l	#1,(TV_SECS,a1)
		move.l	#0,(TV_MICRO,a1)
		JUMP	SendIO

		DONE	StartTimer
;--------------
InitTimer
		CALL	_SysBase,CreateMsgPort
		move.l	d0,(TimePort)
		beq.b	.FAIL
		movea.l	d0,a0
		moveq	#IOTV_SIZE,d0
		CALL	CreateIORequest
		move.l	d0,(TimeRequest)
		beq.b	.FAIL
		movea.l	d0,a1
		lea	(TimerName),a0
		moveq	#UNIT_VBLANK,d0
		moveq	#0,d1
		JUMP	OpenDevice

.FAIL		moveq	#1,d0
		rts
;--------------
		ENTRY	CleanTimer,a2
		move.l	(TimeRequest),d0
		beq.b	.notime
		movea.l	d0,a0
		movea.l	a0,a2
		move.l	(IO_DEVICE,a2),d0
		beq.b	.nodev
		movea.l	a2,a1
		CALL	_SysBase,CheckIO
		bne.b	.noactive
		movea.l	a2,a1
		CALL	AbortIO
.noactive	movea.l	a2,a1
		CALL	CloseDevice

.nodev		movea.l	a2,a0
		CALL	_SysBase,DeleteIORequest
		
.notime		move.l	(TimePort),d0
		beq.b	CleanTimer_done
		movea.l	d0,a0
		CALL	_SysBase,DeleteMsgPort
		DONE	CleanTimer
;--------------
HandleCXEvents
		pushm	d2-d3/a2
		movea.l	(BrokerPort),a0
		CALL	_SysBase,GetMsg
		tst.l	d0
		beq.b CXDONE
		movea.l	d0,a0
		movea.l	a0,a2
		CALL	_CXBase,CxMsgType
		move.l	d0,d2
		movea.l	a2,a0
		CALL	CxMsgID
		move.l	d0,d3
		movea.l	a2,a1
		CALL	_SysBase,ReplyMsg

		moveq	#CXM_IEVENT,d1
		sub.l	d1,d2
		beq.b	.OpenUser
		sub.l	d1,d2
		beq.b	.CXEvents
		bra.b	CXDONE

.OpenUser	tst.l	(mywindow)
		bne.b	CXDONE
		bsr.w	OpenUserWindow
		moveq	#1,d0
		bra.b	CXDONE

.CXEvents	moveq	#CXCMD_DISABLE,d1
		sub.l	d1,d3
		blt.b	CXDONE
		cmpi.l	#9,d3
		bge.b	CXDONE
		IFEQ	_EVAL(mc68020)
		add.w	d3,d3
		move.w	(CXTable,PC,d3.W),d3
		ELSE
		move.w	(CXTable,PC,d3.W*2),d3
		ENDC
		jmp	(CXTable,PC,d3.W)

CXDONE		popm
		rts
;--------------
CXTable
		DR.W	disable,CXTable
		DR.W	CXDONE,CXTable
		DR.W	enable,CXTable
		DR.W	CXDONE,CXTable
		DR.W	appear,CXTable
		DR.W	CXDONE,CXTable
		DR.W	disappear,CXTable
		DR.W	CXDONE,CXTable
		DR.W	kill,CXTable
;--------------
disable
		movea.l	(Broker),a0
		moveq	#FALSE,d0
		CALL	_CXBase,ActivateCxObj
		clr.b	(Activate)
		moveq	#1,d0
		bra.b	CXDONE
;--------------
enable		
		movea.l	(Broker),a0
		moveq	#TRUE,d0
		CALL	_CXBase,ActivateCxObj
		move.b	#1,(Activate)
		moveq	#1,d0
		bra.b	CXDONE
;--------------
appear
		tst.l	(mywindow)
		bne.b	CXDONE
		bsr.w	OpenUserWindow
		moveq	#1,d0
		bra.b	CXDONE
;--------------
disappear
		tst.l	(mywindow)
		beq.b	CXDONE
		bsr.w	CloseUserWindow
		clr.l	(mywindow)
		moveq	#1,d0
		bra.b	CXDONE
;--------------
kill
		moveq	#0,d0
		bra.b	CXDONE				
;--------------
HandleWindowEvents
		pushm	a2-a3/d2-d3
		move.l	(mywindow),d0
		beq.b	HDONE
		movea.l	d0,a0
		movea.l	(wd_UserPort,a0),a0
		CALL	_GadToolsBase,GT_GetIMsg
		tst.l	d0
		beq.b	HDONE
		movea.l	d0,a2
		move.l	(im_Class,a2),d2
		move.w	(im_Code,a2),d3
		movea.l	(im_IAddress,a2),a3
		movea.l	a2,a1
		CALL	GT_ReplyIMsg
		move.l	#MENUPICK,d0
		cmp.l	d0,d2
		bne.b	.noMenuEvent
		cmpi.w	#MENUNULL,d3
		beq.b	HDONE
		moveq	#$3F,d0
		lsr.w	#5,d3
		and.w	d0,d3
		IFEQ	_EVAL(mc68020)
		add.w	d3,d3
		move.w	(WTable,PC,d3.W),d3
		ELSE
		move.w	(WTable,PC,d3.W*2),d3
		ENDC
		jmp	(WTable,PC,d3.W)

.noMenuEvent	move.l	#CLOSEWINDOW,d0
		cmp.l	d0,d2
		bne.b	.noCloseEvent
		bra.b	item1
.noCloseEvent
		moveq	#GADGETUP,d0
		cmp.l	d0,d2
		bne.b	HDONE
		move.w	(gg_GadgetID,a3),d0
		bne.b	HDONE
		movea.l	(gg_SpecialInfo,a3),a3
		move.l	(si_Buffer,a3),d1
		lea	(Time),a0
		move.l	a0,d2
		CALL	_DOSBase,StrToLong
		moveq	#1,d0
HDONE		popm
		rts
;--------------
WTable
		DR.W	item1,WTable
		DR.W	item2,WTable
;-------------
item1
		bsr.w	CloseUserWindow
		clr.l	(mywindow)
		moveq	#1,d0
		bra.b	HDONE
;--------------		
item2
		moveq	#0,d0
		bra.b	HDONE
;--------------		
InitCom
		pushm	a2/a3
		CALL	_SysBase,CreateMsgPort
		move.l	d0,(BrokerPort)
		beq.b	.FAIL
		movea.l	d0,a3
		clr.b	(LN_PRI,a3)
		lea	(NamePort),a1
		move.l	a1,(LN_NAME,a3)
		movea.l	a3,a1
		CALL	AddPort
		
		lea	(nb),a2
		move.l	a3,(nb_Port,a2)
		lea	(localeinfo),a0
		moveq	#TEXT_NOTE,d0
		bsr.w	GetString
		move.l	d0,(nb_Descr,a2)
		
		movea.l	a2,a0
		moveq	#0,d0
		CALL	_CXBase,CxBroker
		move.l	d0,(Broker)
		beq.b	.FAIL	
		movea.l	d0,a2

		movea.l	(Key),a0
		movea.l	a3,a1
		moveq	#ID_HOTKEY,d0				
		bsr.b	HotKey
		tst.l	d0
		beq.b	.FAIL
		movea.l	d0,a1
		movea.l	a2,a0
		CALL	AttachCxObj

		movea.l	a2,a0
		CALL	CxObjError
		tst.l	d0
		bne.b	.FAIL
		moveq	#1,d0
		bra.b	.DONE
.FAIL		moveq	#0,d0
.DONE		popm
		rts
;--------------
HotKey
		pushm	d2/a3/a5
		movea.l	a1,a3
		move.l	d0,d2	
		moveq	#CX_FILTER,d0
		suba.l	a1,a1
		CALL	_CXBase,CreateCxObj
		tst.l	d0
		beq.b	.FAIL
		movea.l	d0,a5
		moveq	#CX_SEND,d0
		movea.l	a3,a0
		movea.l	d2,a1
		CALL	CreateCxObj
		movea.l	a5,a0
		movea.l	d0,a1
		CALL	AttachCxObj
		moveq	#CX_TRANSLATE,d0
		suba.l	a0,a0
		movea.l	a0,a1
		CALL	CreateCxObj
		movea.l	a5,a0
		movea.l	d0,a1
		CALL	AttachCxObj
		movea.l	a5,a0
		CALL	CxObjError
		move.l	d0,d2
		beq.b	.NoError
		movea.l	a5,a0
		CALL	DeleteCxObjAll
		moveq	#0,d0
		bra.b	.FAIL
.NoError	move.l	a5,d0		
.FAIL		popm
		rts
;--------------
CleanCom
		push	a2
		movea.l	(Broker),a0
		move.l	a0,d0
		beq.b	.noBroker
		CALL	_CXBase,DeleteCxObjAll
		
.noBroker	movea.l	(BrokerPort),a0
		move.l	a0,d0
		beq.b	.FAIL
		movea.l	a0,a2

.msgLoop	CALL	_SysBase,GetMsg
		tst.l	d0
		beq.b	.noMsg
		movea.l	d0,a0
		CALL	ReplyMsg
		movea.l	a2,a0
		bra.b	.msgLoop

.noMsg		movea.l	a2,a1
		CALL	RemPort
		movea.l	a2,a0
		CALL	DeleteMsgPort
.FAIL		
		pop	a2
		rts
;--------------
TestSigBlanker
		push	a0
.CheckLoop	move.b	(ie_Class,a0),d0
		cmpi.b	#IECLASS_RAWMOUSE,d0
		beq.b	.Signal
		cmpi.b	#IECLASS_RAWKEY,d0
		beq.b	.Signal
		cmpi.b	#IECLASS_DISKINSERTED,d0
		beq.b	.Signal
		cmpi.b	#IECLASS_DISKREMOVED,d0
		bne.b	.NextEvent
.Signal		clr.l	(TCount)
		move.l	(inputSig),d0
		movea.l	(_Task),a1
		push	a0
		CALL	_SysBase,Signal
		pop	a0

.NextEvent	move.l	(a0),d0
		movea.l	d0,a0
		bne.b	.CheckLoop
		pop	d0
		rts
;--------------
InitInputEvents
		push	a2
		CALL	_SysBase,CreateMsgPort
		move.l	d0,(InputPort)
		beq.b	.FAIL
		movea.l	d0,a0
		moveq	#IOSTD_SIZE,d0
		CALL	CreateIORequest
		move.l	d0,(InputRequest)
		beq.b	.FAIL
		movea.l	d0,a1
		movea.l	a1,a2
		lea	(InputName),a0
		moveq	#0,d0
		moveq	#0,d1
		CALL	OpenDevice
		bne.b	.FAIL
		move.l	#MEMF_CLEAR|MEMF_PUBLIC,d1
		moveq	#IS_SIZE,d0
		CALL	AllocMem
		move.l	d0,(interrupt)
		beq.b	.FAIL
		movea.l	d0,a0
		move.l	#TestSigBlanker,(IS_CODE,a0)
		move.l	#0,(IS_DATA,a0)
		move.b	#51,(LN_PRI,a0)
		move.l	d0,(IO_DATA,a2)
		move.w	#IND_ADDHANDLER,(IO_COMMAND,a2)
		movea.l	a2,a1
		CALL	DoIO
		moveq	#1,d0
		bra.b	InputEvents_done

.FAIL		moveq	#0,d0
InputEvents_done
		pop	a2	
		rts
;--------------
		ENTRY	CleanInputEvents,a2
		move.l	(InputRequest),d0
		beq.b	.noinput
		movea.l	d0,a2
		movea.l	a2,a1
		move.w	#IND_REMHANDLER,(IO_COMMAND,a1)
		move.l	(interrupt),d0
		beq.b	.noRemove
		move.l	d0,(IO_DATA,a1)
		CALL	_SysBase,DoIO
.noRemove	movea.l	a2,a1
		move.l	(IO_DEVICE,a2),d0
		beq.b	.noDev
		CALL	_SysBase,CloseDevice	
.noDev		movea.l	a2,a0
		CALL	DeleteIORequest

.noinput	move.l	(InputPort),d0
		beq.b	.noport
		movea.l	d0,a0
		CALL	_SysBase,DeleteMsgPort
.noport		move.l	(interrupt),d0
		beq.b	CleanInputEvents_done
		movea.l	d0,a1
		moveq	#IS_SIZE,d0
		CALL	_SysBase,FreeMem
		DONE	CleanInputEvents
;--------------
OpenUserWindow
		bsr.w	LockScreen
		bne.b	.LockOK
		bra.w	FREE

.LockOK
		bsr.w	CreateAllGadgets
		bne.b	.gadOk
		bsr.w	FreeAllGadgets
		bsr.w	UnlockScreen
		bra.w	FREE

.gadOk		push	a2
		suba.l	a0,a0
		lea	(mywindowtags),a1
		CALL	_IntuitionBase,OpenWindowTagList
		move.l	d0,(mywindow)
		beq.w	OpenWindow_done		

		lea	(mynewmenu),a2
		lea	(gnm_SIZEOF,a2),a2
		moveq	#MENU_LABEL1,d0
		lea	(localeinfo),a0
		bsr.w	GetString
		move.l	d0,(gnm_Label,a2)
		lea	(gnm_SIZEOF,a2),a2
		moveq	#MENU_LABEL2,d0
		lea	(localeinfo),a0
		bsr.w	GetString
		move.l	d0,(gnm_Label,a2)

		lea	(mynewmenu),a0
		lea	(menutags),a1
		CALL	_GadToolsBase,CreateMenusA
		move.l	d0,(menu)
		beq.b	OpenWindow_done

		movea.l	d0,a0
		movea.l	(visualinfo),a1
		suba.l	a2,a2
		CALL	LayoutMenusA
		tst.l	d0
		beq.b	OpenWindow_done
		
		movea.l	(mywindow),a0
		movea.l	a0,a2
		movea.l	(menu),a1
		CALL	_IntuitionBase,SetMenuStrip	

		movea.l	a2,a0
		suba.l	a1,a1
		CALL	_GadToolsBase,GT_RefreshWindow
OpenWindow_done	pop	a2
		rts
;--------------
CloseUserWindow
		move.l	(mywindow),d0
		beq.b	CloseWind_done
		movea.l	d0,a0
		CALL	_IntuitionBase,ClearMenuStrip

		move.l	(menu),d0
		beq.b	.nomenu
		movea.l	d0,a0
		CALL	_GadToolsBase,FreeMenus

.nomenu		movea.l	(mywindow),a0
		CALL	_IntuitionBase,CloseWindow
		bsr.w	FreeAllGadgets
		move.l	(visualinfo),d0
		beq.b	CloseWind_done
		movea.l	d0,a0
		CALL	FreeVisualInfo		
CloseWind_done	bra.w	UnlockScreen
;--------------						
LockScreen		
		suba.l	a0,a0
		CALL	_IntuitionBase,LockPubScreen
		move.l	d0,(screen)
		beq.b	LockScreen_done
		movea.l	d0,a0
		lea	(TD),a1
		CALL	_GadToolsBase,GetVisualInfoA
		move.l	d0,(visualinfo)
LockScreen_done	rts
;--------------
CreateAllGadgets
		pushm	a2-a4
		lea	(my_gads),a3
		lea	(WG+4),a4
		lea	(glist),a0
		CALL	_GadToolsBase,CreateContext
		tst.l	d0
		beq.b	Create_done

.createOk	movea.l	d0,a2
		moveq	#GAG_LABEL1,d0
		lea	(localeinfo),a0
		bsr.w	GetString
		lea	(gadget1),a1
		move.l	(visualinfo),(gng_VisualInfo,a1)
		move.l	d0,(gng_GadgetText,a1)
		movea.l	a2,a0
		moveq	#INTEGER_KIND,d0
		lea	(gad1tags),a2
		CALL	CreateGadgetA
		move.l	d0,(a3)+

		movea.l	d0,a0
		lea	(gadget2),a1
		move.l	(visualinfo),(gng_VisualInfo,a1)
		moveq	#TEXT_KIND,d0
		lea	(gad2tags),a2
		CALL	CreateGadgetA
		move.l	d0,(a3)
		move.l	(glist),(a4)
Create_done	popm	
		rts
;--------------
FreeAllGadgets
		move.l	(glist),d0
		beq.b	FreeGadget_done
		movea.l	d0,a0
		JUMP	_GadToolsBase,FreeGadgets

FreeGadget_done	rts
;--------------
UnlockScreen	move.l	(screen),d0
		beq.b	Unlock_done
		movea.l	d0,a0
		JUMP	_IntuitionBase,UnlockPubScreen

Unlock_done	rts
;--------------
ReadWBArgs
		pushm	d2-d3/a2-a4
		movea.l	(_WBMsg),a0
		movea.l	(sm_ArgList,a0),a2
		move.l	(wa_Lock,a2),d1
		CALL	_DOSBase,CurrentDir
		move.l	d0,d2
		movea.l	(wa_Name,a2),a0
		CALL	_IconBase,GetDiskObject
		tst.l	d0
		beq.w	.noTools
		movea.l	d0,a2
		movea.l	(do_ToolTypes,a2),a0
		movea.l	a0,a3
		move.l	#TRUE,(rdargs.show)
		lea	(ToolShow.txt),a1
		CALL	FindToolType
		tst.l	d0
		beq.b	.noShow
		movea.l	d0,a0
		movea.l	a0,a4
		lea	(ShowON.txt),a1
		CALL	MatchToolValue
		tst.l	d0
		bne.b	.noShow

.testOFF	movea.l	a4,a0
		lea	(ShowOFF.txt),a1
		CALL	MatchToolValue
		tst.l	d0
		beq.b	.noShow
		move.l	#FALSE,(rdargs.show)

.noShow		movea.l	a3,a0
		lea	(ToolTime.txt),a1
		CALL	FindToolType
		tst.l	d0
		beq.b	.noTime
		movea.l	d0,a0
		lea	(DecBuffer),a1
		STRCPY	a0,a1
		move.l	#DecBuffer,(rdargs.time)	

.noTime		movea.l	a3,a0
		lea	(ToolHotkey.txt),a1
		CALL	FindToolType
		tst.l	d0
		beq.b	.noKey
		movea.l	d0,a0
		lea	(HotBuffer),a1
		STRCPY	a0,a1
		move.l	#HotBuffer,(rdargs.hotkey)

.noKey		movea.l	a2,a0
		CALL	FreeDiskObject	
.noTools	move.l	d2,d1
		CALL	_DOSBase,CurrentDir
		popm
		rts	
;--------------	
GetString
		lea	(CatCompBlock),a1
		bra.b	2$
1$:		move.w	(a1)+,d1
		adda.w	d1,a1
2$:		cmp.l	(a1)+,d0
		bne.b	1$
		addq.l	#2,a1
		move.l	(a0)+,d1
		bne.b	3$
		move.l	a1,d0
		rts
3$:		move.l	a6,-(SP)
		movea.l	d1,a6
		movea.l	(a0),a0
		CALL	GetCatalogStr
		movea.l	(SP)+,a6
		rts

		SECTION	__MERGED,DATA

_Task		ds.l	1
_IntuitionBase	ds.l	1
_IconBase	ds.l	1
_CXBase		ds.l	1
_GadToolsBase	ds.l	1
_LocaleBase	ds.l	1
_GfxBase	ds.l	1
screen		ds.l	1
mywindow	ds.l	1
visualinfo	ds.l	1
menu		ds.l	1
my_gads		ds.l	2
glist		ds.l	1
BrokerPort	ds.l	1
Broker		ds.l	1
timeSig		ds.l	1
inputSig	ds.l	1
TCount		ds.l	1
BlankerScreen	ds.l	1
InputPort	ds.l	1
InputRequest	ds.l	1
TimePort	ds.l	1
TimeRequest	ds.l	1
interrupt	ds.l	1
OldCoords	ds.l	1
NewCoords	ds.l	1
Rnd		ds.w	1
Plan1		ds.l	1
Plan2		ds.l	1
		IFD	SUBTASK
subTask		ds.l	1
globalSig	ds.l	1
		ENDC
buffer		ds.b	512
localeinfo	ds.b	LocaleInfo_SIZEOF
fromWB		ds.b	1
Activate	ds.b	1

DOSName		cstr	"dos.library"
IntuitionName	cstr	"intuition.library"
GraphicsName	cstr	"graphics.library"
LocaleName	cstr	"locale.library"
IconName	cstr	"icon.library"
CommoditiesName	cstr	"commodities.library"
GadToolsName	cstr	"gadtools.library"
TimerName	cstr	"timer.device"
InputName	cstr	"input.device"
CatalogName	cstr	"starsblanker.catalog"
ToolShow.txt	cstr	"SHOW"
ShowON.txt	cstr	"ON"
ShowOFF.txt	cstr	"OFF"
ToolTime.txt	cstr	"SECONDS"
ToolHotkey.txt	cstr	"HOTKEY"

		IFD	SUBTASK
taskName	cstr	"stars.task"
		EVEN
memlist
		ds.b	LN_SIZE
		dc.w	2
ml_AdrTask	EQU	*-memlist
		dc.l	MEMF_PUBLIC|MEMF_CLEAR
		dc.l	TC_SIZE
ml_AdrStack	EQU	*-memlist
		dc.l	MEMF_CLEAR
ml_SizeStack	EQU	*-memlist
		dc.l	0
		ELSE
		EVEN
		ENDC
			
myRequest	dc.l	es_SIZEOF
		dc.l	0
		dc.l	title
		dc.l	0
		dc.l	format

nb		dc.b	NB_VERSION
		dc.b	0
		dc.l	title
		dc.l	Copyright
		dc.l	0
		dc.w	0
		dc.w	COF_SHOW_HIDE
		dc.b	0,0
		dc.l	0
		dc.w	0

blankscreentags	dc.l	SA_Left,0
		dc.l	SA_Top,0
		dc.l	SA_Width,WIDTH
		dc.l	SA_Height,HEIGHT
		dc.l	SA_Depth,DEPTH
		dc.l	SA_DisplayID,LORES_KEY
		dc.l	SA_Type,CUSTOMSCREEN
		dc.l	SA_Quiet,TRUE
		dc.l	SA_Title,NULL
		dc.l	SA_ShowTitle,FALSE
		dc.l	TAG_DONE

ColorTable	dc.w	0,$0335,$0668,$0aac

mywindowtags	dc.l	WA_Left,120
		dc.l	WA_Top,30
		dc.l	WA_Width,300
		dc.l	WA_Height,100
		dc.l	WA_Activate,TRUE
WG		dc.l	WA_Gadgets,0
		dc.l	WA_CloseGadget,TRUE
		dc.l	WA_DragBar,TRUE
		dc.l	WA_DepthGadget,TRUE

;-------------- Tag spcifique au Kickstart V39 et +
		dc.l	WA_NewLookMenus,TRUE

		dc.l	WA_Title,title
		dc.l	WA_IDCMP,IDCMP_CLOSEWINDOW|IDCMP_MENUPICK|IDCMP_GADGETUP
		dc.l	TAG_END

mynewmenu	dc.b	NM_TITLE,0
		dc.l	label
		dc.l	0
		dc.w	0
		dc.l	0,0
		dc.b	NM_ITEM,0
		dc.l	0
		dc.l	comkey1
		dc.w	0
		dc.l	0,0
		dc.b	NM_ITEM,0
		dc.l	0
		dc.l	comkey2
		dc.w	0
		dc.l	0,0
		dc.b	NM_END,0
		dc.l	0,0
		dc.w	0
		dc.l	0,0

menutags	dc.l	GTMN_FrontPen,1
		dc.l	TAG_END

comkey1		cstr	"H"
comkey2		cstr	"Q"

Topaz80		dc.l	topazname
		dc.w	8
		dc.b	0,0

gadget1		dc.w	150,20
		dc.w	52,20
		dc.l	0
		dc.l	Topaz80
		dc.w	MYGAD_INT
		dc.l	PLACETEXT_LEFT
		dc.l	0
		dc.l	0


gadget2		dc.w	150,60
		dc.w	120,20
		dc.l	gad2.txt
		dc.l	Topaz80
		dc.w	MYGAD_STRING
		dc.l	PLACETEXT_LEFT
		dc.l	0
		dc.l	0

gad1tags	dc.l	GTIN_Number
Time		dc.l	60
		dc.l	GTIN_MaxChars,4
		dc.l	STRINGA_Justification,GACT_STRINGLEFT
		dc.l	TAG_DONE

gad2tags	dc.l	GTTX_Text	
Key		dc.l	defautkey
		dc.l	GTTX_Border,TRUE
TD		dc.l	TAG_DONE

topazname	cstr	"topaz.font"		
gad2.txt	cstr	"Hotkey: "
NamePort	dc.b	"StarsBlanker.port",0
title		cstr	"StarsBlanker"
Copyright	cstr	"StarsBlanker  Pat 1994"
format		cstr	"OK"

version		cstr	"$VER: StarsBlanker 1.00 (24.2.94)"

label		cstr	"Projet"
defautkey	cstr	"control lalt s"	
template	dc.b	"SHOW/S,"
		dc.b	"SECONDS/N,"
		dc.b	"HOTKEY/K,"
		dc.b	"?=HELP/S"
		dc.b	0	
hello.msg	dc.b	"\C1;33m"
		dc.b	"StarsBlanker  Pat (24/02/94)"
		dc.b	"\C0;39m \N",0
usage.msg	dc.b	"SHOW/S SECONDS/N HOTKEY/K:\N",0
template.Help	dc.b	"SHOW/S,"
		dc.b	"SECONDS/N,"
		dc.b	"HOTKEY/K,"
		dc.b	0

		SECTION	Localized,DATA

CatCompBlock	DC.L $0
		DC.W $6
		DC.B 'Hide',$00,$00
		DC.L $1
		DC.W $6
		DC.B 'Quit',$00,$00
		DC.L $2
		DC.W $0A
		DC.B 'Seconds:',$00,$00
		DC.L $3
		DC.W $18
		DC.B 'Another screen blanker',$00,$00
		DC.L $4
		DC.W $18
		DC.B 'Input device not open',10,$00,$00
		DC.L $5
		DC.W $18
		DC.B 'Timer device not open',10,$00,$00
		DC.L $6
		DC.W $1C
		DC.B 'Commodities not installed',10,$00,$00
		DC.L $7
		DC.W $16
		DC.B 'Port already active',10,$00,$00
		DC.L $8
		DC.W $1A
		DC.B 'Can',39,'t find icon.library',10,$00,$00
		DC.L $9
		DC.W $1E
		DC.B 'Can',39,'t find graphics.library',10,$00,$00
		DC.L $A
		DC.W $20
		DC.B 'Can',39,'t find commodities.library',10,$00
		DC.L $B
		DC.W $1E
		DC.B 'Can',39,'t find gadtools.library',10,$00,$00

		IFD	CPR
		IFEQ	_errCount+_warnCount
		IFND	SUBTASK
		IFD	_M68020
		ONEXIT	'run >nil: <nil: slink with StarsBlanker020.lnk'
		ELSE
		ONEXIT	'run >nil: <nil: slink with StarsBlanker.lnk'
		ENDC
		ELSE
		IFD	_M68020
		ONEXIT	'run >nil: <nil: slink with TaskStarsBlanker020.lnk'
		ELSE
		ONEXIT	'run >nil: <nil: slink with TaskStarsBlanker.lnk'
		ENDC
		ENDC
		ENDC
		ENDC
		
		END

Directives: 	MC68020/MC68000 -> Choix type processeur/instructions 
		EXOBJ ->  excutable
		OBJFILE -> nom du fichier gnr lors de l'assemblage.
			<-> OUTPUT
		STRICT -> utilise la syntaxe prcise des instructions.
		exemples:   sub.l a0,a0 -> suba.l a0,a0
			    move.l d1,a1 -> movea.l d1,a1
			    cmp.w #2,d0 -> cmpi.w #2,d0
		NEWSYNTAX -> utilise la nouvelle syntaxe dfinie par
			     MOTOROLA pour l'ensemble de la gamme 68000.
		exemples:   move.l $4.w,a6 -> movea.l ($4).w,a6
			    move.l d0,_GfxBase -> move.l d0,(_GfxBase)
			    move.l d0,8(a2) -> move.l d0,(8,a2)
			    beq.s -> beq.b
			    bra.l -> bra.w
		MULTIPASS -> optimisation
		INCPATH <-> INCDIR
		MACFILE	<-> INCLUDE	
		ESCAPESTR -> permet d'intoduire des squences d'chappement
			     dans une chaine de caractres.
			     DC.B "chaine\N",0 -> DC.B "chaine",10,0

		SETRL -> dfinie une liste provisoire de registres.
		CSTR "chaine" -> DC.B "chaine",0
		EQUSTR -> dfinie une chaine  un symbole.
		COMMENT -> commentaire sans * et ;.
		ADDSYM -> Ajout d'informations pour dboguer (symbol hunk).
		DEBUG -> Ajout d'informations pour dboguer (debug hunk).
			 Pour StarsBlanker, au format LATTICE4.
			(vivement un format totalement compatible 
			SAS/C V6 !!!).
		_EVAL -> retourne des informations concernant la directive
			donne. De nombreuses directives existent pour le
			Macro68.
		exemples: _EVAL(section) -> retourne le numro de la section.
			  _EVAL(mc68020) -> retourne VRAI si mode 68020.
			  _EVAL(strict) -> retourne VRAI si mode STRICT.
		_MOVEMBYTES -> Permet d'obtenir le nombre d'octets dplacs
			       lors de la dernire instruction MOVEM. 
		_errCount -> nombre d'erreurs.
		_warnCount -> nombre d'avertissements.
		ONEXIT -> excute la commande aprs la cration du fichier
			  donn par la directive OBJFILE.	

StarsBlanker fonctionne  partir de l'AmigaDos 2.1.
starsblanker.catalog est  install dans PROGDIR:catalogs/franais ou
dans LOCALE:catalogs/franais.
A partir du CLI, la syntaxe de StarsBlanker est la suivante:
	StarsBlanker [[show]|[secondes]|[hotkey="..."]]
	StarsBlanker ?=help
A partir du Workbench, Un tooltype SHOW=[ON|OFF], SECONDS=..., HOTKEY=...
peut exister dans StarsBlanker.info.
Comme StarsBlanker se dtache du Shell, vous n'avez pas besoin de le lancer 
avec la commande run.

StarsBlanker est librement distribuable mais sans une seule modification 
et dans son intgralit.
Liste des fichiers fournis:	
		StarsBlanker.asm
		StarsBlanker	
		StarsBlanker.info
		StarsBlanker.lnk
		StarsBlanker020
		StarsBlanker020.info
		StarsBlanker020.lnk
		TaskStarsBlanker	--->  essayer simplement.
		StarsBlanker020.ld	---> uniquement pour dboguer.
		usermacs.i
		StarsBlanker.cd
		empty.ct
		franais.ct
		starsblanker.catalog
		SB_strings.asm

Thanks to G.Kurz (snoopy 1.4) for the idea of following macros: 
		ENTRY, DONE, DETACHSTARTUP.


Contacts:	RAULT Patrice
		1, rue Gabriel Pri
		29200 BREST  
		FRANCE

